import 'package:edahapi/edah_api.dart';
import 'package:edahapi/models/models.dart';

class Course {
  final EDAHApI _api;
  static const String _name = 'EmpRecorder?';

  Course(this._api);
  

  Future<CourseModel?> oneCourse(int id) async {
    String endPoint = "course-content/$id";
    return await _api.request<CourseModel?>('get', endPoint,
        jsonResponse: (json) => CourseModel.fromJson(json),
        errorResponse: (err) => CourseModel.error(err));
  }
   Future<AllCourseModel?> allCourse() async {
    String endPoint = "all-courses";
    return await _api.request<AllCourseModel?>('get', endPoint,
        jsonResponse: (json) => AllCourseModel.fromJson(json),
        errorResponse: (err) => AllCourseModel.error(err));
  }
}
