library edahapi;

import 'dart:convert';

import 'package:edahapi/EndPoints/course.dart';
import 'package:edahapi/EndPoints/user.dart';
import 'package:http/http.dart';

class EDAHApI {
  final String url;
  final Client _httpClient = Client();
  EDAHApI(this.url);

  User get user => User();
  Course get course => Course(this);

  bool? _debugMode;
  getMethod(String parm) {
    return 'getMethod';
  }

  String _createFullPath(String path) {
    return '$url/$path';
  }

  /// WooSignal Request
  /*Future<T?> _wooSignalRequest<T>(
      {dynamic payload = const {},
      required String method,
      required String path,
      required T Function(dynamic json) jsonResponse,
      String postUrl = "/request"}) async {
    _printLog("Parameters: " + payload.toString());
    payload = _standardPayload(method, payload, path);

    dynamic json = await _apiProvider.post(postUrl, payload);
    if (json is Map<String, dynamic> && json.containsKey('error')) {
      _printLog(json['error']);
      return null;
    }

    T model;
    try {
      model = jsonResponse(json);
    } on Exception catch (e) {
      _printLog(e.toString());
      return null;
    }

    _printLog(model.toString());
    return model;
  }*/
  /// Print to the console a [message]
  void _printLog(String message) {
    if (_debugMode == true) {
      print("WOOSIGNAL LOG: " + message);
    }
  }

  Future<T?> request<T>(
    String method,
    String path, {
    Map<String, String>? headers,
    dynamic body,
    bool? customPath,
    required T Function(dynamic json) jsonResponse,
    required T Function(String err) errorResponse,
  }) async {
    try {
      var url = Uri.parse(customPath == true ? path : _createFullPath(path));

      dynamic json;
      switch (method) {
        case 'post':
          json = await post(url, headers: headers, body: body);
          break;
        case 'get':
          json = await get(url, headers: headers);
          break;
      }
      if (json == null) throw Exception("Data Can n,t Respones Form Server");
      T model;
      Map<String, dynamic> res = jsonDecode(json);
  
      model = jsonResponse(res);
      return model;
    } catch (error, stacktrace) {
      _printLog("$error stackTrace: $stacktrace");
      return errorResponse(error.toString());
      //throw ResponseException(e.toString(), e.hashCode);
    }
  }

  Future<dynamic> post(
    url, {
    Map<String, String>? headers,
    dynamic body,
  }) async {
    try {
      Response response =
          await _httpClient.post(url, headers: headers, body: body);
      return response.body;
    } catch (error, stacktrace) {
      _printLog("$error stackTrace: $stacktrace");
      return null;
    }
  }

  Future<dynamic> get(
    url, {
    Map<String, String>? headers,
    dynamic body,
  }) async {
    try {
      Response response = await _httpClient.get(url, headers: headers);
      return response.body;
    } catch (error, stacktrace) {
      _printLog("$error stackTrace: $stacktrace");
      return null;
    }
  }
}

abstract class Imodel<T> {
  Imodel();
  fromJson(Map<String, dynamic> dataJson) {}
  Imodel.toJson() {}
}
 