import 'package:edahapi/models/category_model.dart';

mixin CourseProp {
  String? status_code;
  String? message;
  CourseDataModel? course;
  String? photo;
  String? price;
}

class CourseModel with CourseProp {
  CourseModel.fromJson(json) {
    try {
      status_code = json['status_code'];
      message = json['message'];
      course = CourseDataModel.fromJson(json['data']['course']);
      photo = json['data']['photo'];
      price = json['data']['price'];
    } catch (ex) {
      throw ex.toString();
    }
  }

  CourseModel.error(String err) {}
}

class CourseModelForAll with CourseProp {
  CourseModelForAll.fromJson(json) {
    try {
      course = CourseDataModel.fromJson(json['course']);
      photo = json['photo'];
      price = json['price'];
    } catch (ex) {
      throw ex.toString();
    }
  }
}

class AllCourseModel {
  // ignore: non_constant_identifier_names
  String? status_code;
  String? message;
  List<CourseModelForAll> courses = [];
  String? photo;
  AllCourseModel({this.status_code, this.message, required this.courses});
  AllCourseModel.fromJson(Map<String, dynamic> json) {
    try {
      status_code = json['status_code'];
      message = json['message'];
      json['data'].forEach((value) {
        courses.add(CourseModelForAll.fromJson(value));
      });
    } catch (ex) {
      throw ex.toString();
    }
  }

  AllCourseModel.error(String err) {}
}

class CourseDataModel {
  int? id;
  String? postAuthor;
  String? postDate;
  String? postDateGmt;
  String? postContent;
  String? postTitle;
  String? postExcerpt;
  String? postStatus;
  String? commentStatus;
  String? pingStatus;
  String? postPassword;
  String? postName;
  String? toPing;
  String? pinged;
  String? postModified;
  String? postModifiedGmt;
  String? postContentFiltered;
  int? postParent;
  String? guid;
  int? menuOrder;
  String? postType;
  String? postMimeType;
  String? commentCount;
  CategoryDataModel? courseCategory;
  String? courseTag;

  CourseDataModel.fromJson(var json) {
    id = json['ID'];
    postAuthor = json['post_author'];
    postDate = json['post_date'];
    postDateGmt = json['post_date_gmt'];
    postContent = json['post_content'];
    postTitle = json['post_title'];
    postExcerpt = json['post_excerpt'];
    postStatus = json['post_status'];
    commentStatus = json['comment_status'];
    pingStatus = json['ping_status'];
    commentStatus = json['comment_status'];
    pingStatus = json['ping_status'];
    postPassword = json['post_password'];
    postName = json['post_name'];
    toPing = json['to_ping'];
    pinged = json['pinged'];
    postModified = json['post_modified'];
    postModifiedGmt = json['post_modified_gmt'];
    postContentFiltered = json['post_content_filtered'];
    postParent = json['post_parent'];
    guid = json['guid'];
    menuOrder = json['menu_order'];
    postType = json['post_type'];
    postMimeType = json['post_mime_type'];
    commentCount = json['comment_count'];
    courseCategory = CategoryDataModel.fromJson(json['course_category'][0]);
  }
}
